using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;
using System.Net;
using System.Runtime.InteropServices;

using GnucDNA;

namespace GnucCS
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form {
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.Timer timer1;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.StatusBar statusBar1;

		private GnucDNA.Core DnaCore;
		private GnucDNA.Cache DnaCache;
		private GnucDNA.Prefs DnaPrefs;
		private GnucDNA.Network DnaNet;
		private GnucDNA.Search DnaSearch;

		private int	currentSearchId;

		private Hashtable nodeHash;
		private Hashtable searchHash;

		private System.Windows.Forms.StatusBarPanel statusBarPanel1;
		private System.Windows.Forms.StatusBarPanel statusBarPanel2;
		private System.Windows.Forms.StatusBarPanel statusBarPanel3;
		private System.Windows.Forms.TextBox txtSearch;
		private System.Windows.Forms.Button btnSearch;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.ListView lstNetwork;
		private System.Windows.Forms.ColumnHeader colNode;
		private System.Windows.Forms.ColumnHeader colStatus;
		private System.Windows.Forms.ColumnHeader colBandWidth;
		private System.Windows.Forms.ColumnHeader colClient;
		private System.Windows.Forms.ColumnHeader colUpTime;
		private System.Windows.Forms.TabPage tabPage2;
		private System.Windows.Forms.ListView lstSearch;
		private System.Windows.Forms.ColumnHeader colFile;
		private System.Windows.Forms.ColumnHeader colSize;
		private System.Windows.Forms.ColumnHeader colHash;
		private System.Windows.Forms.ColumnHeader colHosts;
		private System.Windows.Forms.TabControl tabControl1;

		private System.Collections.Hashtable nodeList;

		public Form1() {
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			nodeHash = new Hashtable();
			searchHash = new Hashtable();

			DnaCore		= new GnucDNA.Core();
			DnaPrefs	= (GnucDNA.Prefs)DnaCore.GetIPrefs();
			DnaCache	= (GnucDNA.Cache)DnaCore.GetICache();
			DnaNet		= (GnucDNA.Network)DnaCore.GetINetwork();
			DnaSearch	= (GnucDNA.Search)DnaCore.GetISearch();

			string version = DnaCore.GetCoreVersion();
			int intver = System.Convert.ToInt32(version.Replace(".",""));

			if ( intver < 906 ) {
				MessageBox.Show("Wrong version (" + version + ") of GnucDNA found!","GnucDNA Version Error");
				Application.Exit();
			}

			nodeList = new Hashtable();

			timer1.Interval = 1500;
			timer1.Start();

			DnaCore.ClientCode = "JTGC";
			DnaCore.ClientName = "JT Gnutella Client";
			DnaCore.ClientVersion = "0.0.0.2";

			DnaPrefs.LoadConfig(Application.StartupPath + @"\GnucCS.ini");
			DnaCache.LoadWebCache(Application.StartupPath + @"\WebCache.ini");

			if ( DnaCache.GetWebCacheSize() == 0 ) {
				DnaCache.AddWebCache("http://www.gnucleus.net/gcache/gcache.php");
				DnaCache.AddWebCache("http://gwebcache.jonatkins.com/cgi-bin/gwebcache.cgi");
				DnaCache.AddWebCache("http://corky.net/gcache/gcache.php");
			}

			DnaNet.OnChange		+= new GnucDNA._INetworkEvent_OnChangeEventHandler(DnaNet_OnChange);
			DnaSearch.OnRefresh	+= new GnucDNA._ISearchEvent_OnRefreshEventHandler(DnaSearch_OnRefresh);
			DnaSearch.OnResult	+= new GnucDNA._ISearchEvent_OnResultEventHandler(DnaSearch_OnResult);
			DnaSearch.OnUpdate	+= new GnucDNA._ISearchEvent_OnUpdateEventHandler(DnaSearch_OnUpdate);

			DnaNet.ForceUltrapeer(true);

			DnaCore.Connect();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.statusBarPanel1 = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanel2 = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanel3 = new System.Windows.Forms.StatusBarPanel();
			this.txtSearch = new System.Windows.Forms.TextBox();
			this.btnSearch = new System.Windows.Forms.Button();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.lstNetwork = new System.Windows.Forms.ListView();
			this.colNode = new System.Windows.Forms.ColumnHeader();
			this.colStatus = new System.Windows.Forms.ColumnHeader();
			this.colBandWidth = new System.Windows.Forms.ColumnHeader();
			this.colClient = new System.Windows.Forms.ColumnHeader();
			this.colUpTime = new System.Windows.Forms.ColumnHeader();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.lstSearch = new System.Windows.Forms.ListView();
			this.colFile = new System.Windows.Forms.ColumnHeader();
			this.colSize = new System.Windows.Forms.ColumnHeader();
			this.colHash = new System.Windows.Forms.ColumnHeader();
			this.colHosts = new System.Windows.Forms.ColumnHeader();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel3)).BeginInit();
			this.tabPage1.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.tabControl1.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2});
			this.menuItem1.Text = "&File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "E&xit";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// timer1
			// 
			this.timer1.Interval = 1000;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 355);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.statusBarPanel1,
																						  this.statusBarPanel2,
																						  this.statusBarPanel3});
			this.statusBar1.ShowPanels = true;
			this.statusBar1.Size = new System.Drawing.Size(640, 22);
			this.statusBar1.TabIndex = 2;
			// 
			// statusBarPanel1
			// 
			this.statusBarPanel1.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarPanel1.Width = 374;
			// 
			// statusBarPanel2
			// 
			this.statusBarPanel2.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
			this.statusBarPanel2.Width = 125;
			// 
			// statusBarPanel3
			// 
			this.statusBarPanel3.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
			this.statusBarPanel3.Width = 125;
			// 
			// txtSearch
			// 
			this.txtSearch.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.txtSearch.Location = new System.Drawing.Point(8, 320);
			this.txtSearch.Name = "txtSearch";
			this.txtSearch.Size = new System.Drawing.Size(160, 20);
			this.txtSearch.TabIndex = 3;
			this.txtSearch.Text = "";
			// 
			// btnSearch
			// 
			this.btnSearch.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.btnSearch.Location = new System.Drawing.Point(176, 320);
			this.btnSearch.Name = "btnSearch";
			this.btnSearch.TabIndex = 4;
			this.btnSearch.Text = "&Search";
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.lstNetwork});
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(616, 286);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "Network";
			// 
			// lstNetwork
			// 
			this.lstNetwork.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.colNode,
																						 this.colStatus,
																						 this.colBandWidth,
																						 this.colClient,
																						 this.colUpTime});
			this.lstNetwork.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lstNetwork.FullRowSelect = true;
			this.lstNetwork.Name = "lstNetwork";
			this.lstNetwork.Size = new System.Drawing.Size(616, 286);
			this.lstNetwork.TabIndex = 0;
			this.lstNetwork.View = System.Windows.Forms.View.Details;
			// 
			// colNode
			// 
			this.colNode.Text = "Node";
			this.colNode.Width = 120;
			// 
			// colStatus
			// 
			this.colStatus.Text = "Status";
			this.colStatus.Width = 175;
			// 
			// colBandWidth
			// 
			this.colBandWidth.Text = "Bandwidth";
			this.colBandWidth.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.colBandWidth.Width = 80;
			// 
			// colClient
			// 
			this.colClient.Text = "Client";
			this.colClient.Width = 175;
			// 
			// colUpTime
			// 
			this.colUpTime.Text = "Up Time";
			// 
			// tabPage2
			// 
			this.tabPage2.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.lstSearch});
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(616, 286);
			this.tabPage2.TabIndex = 1;
			this.tabPage2.Text = "Search";
			// 
			// lstSearch
			// 
			this.lstSearch.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.colFile,
																						this.colSize,
																						this.colHash,
																						this.colHosts});
			this.lstSearch.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lstSearch.FullRowSelect = true;
			this.lstSearch.Name = "lstSearch";
			this.lstSearch.Size = new System.Drawing.Size(616, 286);
			this.lstSearch.TabIndex = 0;
			this.lstSearch.View = System.Windows.Forms.View.Details;
			// 
			// colFile
			// 
			this.colFile.Text = "File";
			this.colFile.Width = 250;
			// 
			// colSize
			// 
			this.colSize.Text = "Size";
			this.colSize.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.colSize.Width = 90;
			// 
			// colHash
			// 
			this.colHash.Text = "Hashed";
			this.colHash.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// colHosts
			// 
			this.colHosts.Text = "Hosts";
			this.colHosts.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// tabControl1
			// 
			this.tabControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.tabControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tabPage1,
																					  this.tabPage2});
			this.tabControl1.ItemSize = new System.Drawing.Size(52, 18);
			this.tabControl1.Location = new System.Drawing.Point(8, 0);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(624, 312);
			this.tabControl1.TabIndex = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(640, 377);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabControl1,
																		  this.btnSearch,
																		  this.txtSearch,
																		  this.statusBar1});
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "GnucCS";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel3)).EndInit();
			this.tabPage1.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.tabControl1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() {
			Application.Run(new Form1());
		}

		#region Misc Control & Form Events

		private void timer1_Tick(object sender, System.EventArgs e) {
			double ul;
			double dl;
			long nbrNodes = DnaNet.GetNormalConnectedCount();
			ul = (double)DnaCore.GetBytesPerSecUp() / 1024;
			dl = (double)DnaCore.GetBytesPerSecDown() / 1024;
			if ( DnaCore.IsConnecting() && nbrNodes == 0 ) {
				statusBar1.Panels[0].Text = "Connecting...";
				btnSearch.Enabled = false;
				txtSearch.Enabled = false;
			} else if ( DnaCore.IsConnecting() ) {
				statusBar1.Panels[0].Text = nbrNodes + " nodes";
				btnSearch.Enabled = true;
				txtSearch.Enabled = true;
			}

			statusBar1.Panels[1].Text = "Receive: " + ul.ToString("F") + " KB/s";
			statusBar1.Panels[2].Text = "Send: " + dl.ToString("F") + " KB/s";

			int NodeId;
			int state;
			string msg;
			DateTime dt;
			DateTime now = DateTime.Now;
			TimeSpan up;
			double bw;
			string uptime = "";

			for ( int i = 0; i < lstNetwork.Items.Count; i++ ) {
				NodeId = (int)lstNetwork.Items[i].Tag;
				state = DnaNet.GetNodeState(NodeId);
				if ( state == 2 ) {
					bw = (double)(DnaNet.GetNodeBytesUp(NodeId) + DnaNet.GetNodeBytesDown(NodeId)) / 1024;
					msg = bw.ToString("F") + " KB/s";
					dt = DnaNet.GetNodeConnectTime(NodeId);
					up = now.Subtract(dt);
					uptime = "";
					if ( up.Days > 0 )
						uptime = up.Days + "d " + up.Hours + "h " + up.Minutes + "m " + up.Seconds + "s";
					else if ( up.Hours > 0 )
						uptime = up.Hours + "h " + up.Minutes + "m " + up.Seconds + "s";
					else if ( up.Minutes > 0 )
						uptime = up.Minutes + "m " + up.Seconds + "s";
					else 
						uptime = up.Seconds + "s";
					lstNetwork.Items[i].SubItems[2].Text = msg;
					lstNetwork.Items[i].SubItems[3].Text = DnaNet.GetNodeAgent(NodeId);
					lstNetwork.Items[i].SubItems[4].Text = uptime;
				}
			}
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
			DnaNet.OnChange		-= new GnucDNA._INetworkEvent_OnChangeEventHandler(DnaNet_OnChange);
			DnaSearch.OnRefresh	-= new GnucDNA._ISearchEvent_OnRefreshEventHandler(DnaSearch_OnRefresh);
			DnaSearch.OnResult	-= new GnucDNA._ISearchEvent_OnResultEventHandler(DnaSearch_OnResult);
			DnaSearch.OnUpdate	-= new GnucDNA._ISearchEvent_OnUpdateEventHandler(DnaSearch_OnUpdate);
			DnaSearch.EndSearch(currentSearchId);
			DnaCore.Disconnect();
			DnaPrefs.SaveConfig(Application.StartupPath + @"\GnucCS.ini");
			DnaCache.SaveWebCache(Application.StartupPath + @"\WebCache.ini");
			Marshal.ReleaseComObject(DnaCore);
			DnaCore	= null;
		}

		private void btnSearch_Click(object sender, System.EventArgs e) {
			DnaSearch.EndSearch(currentSearchId);
			lstSearch.Items.Clear();
			searchHash.Clear();
			currentSearchId = DnaSearch.StartSearch(txtSearch.Text);
			txtSearch.Text = "";
		}

		#endregion

		#region GnucDNA INetwork Events

		private void DnaNet_OnChange(int NodeId) {

			string nodeState;
			string nodeType;

			ListViewItem item1;
		
			long nbrNodes = DnaNet.GetNormalConnectedCount();
			long state = DnaNet.GetNodeState(NodeId);
			long port = DnaNet.GetNodePort(NodeId);
			long ip = DnaNet.GetNodeIP(NodeId);
			long mode = DnaNet.GetNodeMode(NodeId);

			// handle bug in GnucDNA 0.9.0.6 that's leaking browse requests
			if ( ip == 0 && port == 0 )
				return;

			IPAddress ipaddr = new IPAddress(ip);

			string host = ipaddr.ToString() + ":" + port.ToString();

			switch ( state ) {
				case 0:
					nodeState = "Unknown";
					break;
				case 1:
					nodeState = "Connecting...";
					break;
				case 2:
					nodeState = "Connected";
					break;
				case 3:
					nodeState = "Disconnected";
					break;
				default:
					nodeState = "?";
					break;
			}

			switch ( mode ) {
				case 1:
					nodeType = "Normal";
					break;
				case 2:
					nodeType = "Ultrapeer";
					break;
				case 3:
					nodeType = "Leaf";
					break;
				default:
					nodeType = "Unknown";
					break;
			}

			if ( nodeList.Contains(NodeId) ) {
				item1 = (ListViewItem)nodeList[NodeId];
				if ( state == 3 ) {
					item1.Remove();
					nodeList.Remove(NodeId);
				} else {
					item1.SubItems[1].Text = nodeState;
				}
				if ( state == 2 ) {
					item1.SubItems[1].Text = nodeType;
				}
			} else {
				if ( state < 3 ) {
					item1 = new ListViewItem(host);
					item1.Tag = NodeId;
					item1.SubItems.Add(nodeState);
					item1.SubItems.Add("");
					item1.SubItems.Add("");
					item1.SubItems.Add("");
					lstNetwork.Items.Add(item1);
					nodeList.Add(NodeId,item1);
				}
			}

		}
		#endregion

		#region GnucDNA ISearch Events

		private void DnaSearch_OnRefresh(int SearchId) {
		}

		private void DnaSearch_OnResult(int SearchId, int ResultId) {

			if ( SearchId != currentSearchId )
				return;

			string resultName;
			long size;
			string hash;
			long hostCount;
			ListViewItem item1;

			resultName = DnaSearch.GetResultName(SearchId, ResultId);
			size = DnaSearch.GetResultSize(SearchId, ResultId);
			hash = DnaSearch.GetResultHash(SearchId, ResultId, 0);
			hostCount = DnaSearch.GetResultHostCount(SearchId, ResultId);
			if ( hash == "" )
				hash = "No";
			else
				hash = "Yes";

			if ( searchHash.Contains(ResultId) ) {
				item1 = (ListViewItem)searchHash[ResultId];
				item1.SubItems[1].Text = size.ToString("no");
				item1.SubItems[2].Text = hash;
				item1.SubItems[3].Text = hostCount.ToString();
			} else {
				item1 = new ListViewItem(resultName);
				item1.Tag = ResultId;
				item1.SubItems.Add(size.ToString("n0"));
				item1.SubItems.Add(hash);
				item1.SubItems.Add(hostCount.ToString());
				lstSearch.Items.Add(item1);
				searchHash.Add(ResultId,item1);
			}

		}

		private void DnaSearch_OnUpdate(int SearchId, int ResultId) {

			if ( searchHash.Contains(ResultId) ) {
				ListViewItem item1;
				long size = DnaSearch.GetResultSize(SearchId, ResultId);
				string hash = DnaSearch.GetResultHash(SearchId, ResultId, 0);
				long hostCount = DnaSearch.GetResultHostCount(SearchId, ResultId);
				if ( hash == "" )
					hash = "No";
				else
					hash = "Yes";
				item1 = (ListViewItem)searchHash[ResultId];
				item1.SubItems[1].Text = size.ToString("n0");
				item1.SubItems[2].Text = hash;
				item1.SubItems[3].Text = hostCount.ToString();
			}

		}

		#endregion

		private void menuItem2_Click(object sender, System.EventArgs e) {
			this.Close();
		}

	}
}
